-- Table: "CART_ORDER"

-- DROP TABLE "CART_ORDER";

CREATE TABLE "CART_ORDER"
(
  "CART_ORDER_ID" bigint NOT NULL,
  "DATE_OF_ORDER" date,
  "CUSTOMER_ID" bigint,
  CONSTRAINT "CART_ORDER_PK" PRIMARY KEY ("CART_ORDER_ID"),
  CONSTRAINT "CART_ORDER_FK_CUSTOMER_ID" FOREIGN KEY ("CUSTOMER_ID")
      REFERENCES "CUSTOMER" ("CUSTOMER_ID") MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
)
WITH (
  OIDS=FALSE
);
ALTER TABLE "CART_ORDER" OWNER TO "WASDSND1";


-- Table: "COMPANY"

-- DROP TABLE "COMPANY";

CREATE TABLE "COMPANY"
(
  "COMPANY_ID" bigint NOT NULL,
  "COMPANY" character varying(255),
  CONSTRAINT "COMPANY_PK" PRIMARY KEY ("COMPANY_ID")
)
WITH (
  OIDS=FALSE
);
ALTER TABLE "COMPANY" OWNER TO "WASDSND1";


-- Table: "CUSTOMER"

-- DROP TABLE "CUSTOMER";

CREATE TABLE "CUSTOMER"
(
  "CUSTOMER_ID" bigint NOT NULL,
  "LAST_NAME" character varying,
  "FIRST_NAME" character varying,
  "COMPANY_ID" bigint,
  CONSTRAINT "CUSTOMER_PK" PRIMARY KEY ("CUSTOMER_ID"),
  CONSTRAINT "CUSTOMER_FK_COMPANY_ID" FOREIGN KEY ("COMPANY_ID")
      REFERENCES "COMPANY" ("COMPANY_ID") MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
)
WITH (
  OIDS=FALSE
);
ALTER TABLE "CUSTOMER" OWNER TO "WASDSND1";


-- Table: "LINE_ITEM"

-- DROP TABLE "LINE_ITEM";

CREATE TABLE "LINE_ITEM"
(
  "LINE_ITEM_ID" bigint NOT NULL,
  "PRODUCT_ID" bigint,
  "QUANTITY" bigint,
  "CART_ORDER_ID" bigint,
  CONSTRAINT "LINE_ITEM_PK" PRIMARY KEY ("LINE_ITEM_ID"),
  CONSTRAINT "LINE_ITEM_FK_CART_ORDER_ID" FOREIGN KEY ("CART_ORDER_ID")
      REFERENCES "CART_ORDER" ("CART_ORDER_ID") MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT "LINE_ITEM_FK_PRODUCT_ID" FOREIGN KEY ("PRODUCT_ID")
      REFERENCES "PRODUCT" ("PRODUCT_ID") MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
)
WITH (
  OIDS=FALSE
);
ALTER TABLE "LINE_ITEM" OWNER TO "WASDSND1";


-- Table: "PRODUCT"

-- DROP TABLE "PRODUCT";

CREATE TABLE "PRODUCT"
(
  "PRODUCT_ID" bigint NOT NULL,
  "NAME" character varying,
  "DESCRIPTION" character varying(1000),
  "PRICE" double precision,
  CONSTRAINT "PRODUCT_PK" PRIMARY KEY ("PRODUCT_ID")
)
WITH (
  OIDS=FALSE
);
ALTER TABLE "PRODUCT" OWNER TO "WASDSND1";
