// WARNING: DO NOT EDIT THIS FILE. THIS FILE IS MANAGED BY SPRING ROO.
// You may push code into the target .java compilation unit if you wish to edit any member(s).

package com.malsolo.crm.web;

import com.malsolo.crm.domain.CartOrder;
import com.malsolo.crm.domain.Company;
import com.malsolo.crm.domain.Customer;
import java.io.UnsupportedEncodingException;
import java.lang.Integer;
import java.lang.Long;
import java.lang.String;
import java.util.Collection;
import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;
import org.springframework.ui.Model;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.util.UriUtils;
import org.springframework.web.util.WebUtils;

privileged aspect CustomerController_Roo_Controller {
    
    @RequestMapping(method = RequestMethod.POST)
    public String CustomerController.create(@Valid Customer customer, BindingResult bindingResult, Model uiModel, HttpServletRequest httpServletRequest) {
        if (bindingResult.hasErrors()) {
            uiModel.addAttribute("customer", customer);
            return "customers/create";
        }
        uiModel.asMap().clear();
        customer.persist();
        return "redirect:/customers/" + encodeUrlPathSegment(customer.getCustomerId().toString(), httpServletRequest);
    }
    
    @RequestMapping(params = "form", method = RequestMethod.GET)
    public String CustomerController.createForm(Model uiModel) {
        uiModel.addAttribute("customer", new Customer());
        return "customers/create";
    }
    
    @RequestMapping(value = "/{customerId}", method = RequestMethod.GET)
    public String CustomerController.show(@PathVariable("customerId") Long customerId, Model uiModel) {
        uiModel.addAttribute("customer", Customer.findCustomer(customerId));
        uiModel.addAttribute("itemId", customerId);
        return "customers/show";
    }
    
    @RequestMapping(method = RequestMethod.GET)
    public String CustomerController.list(@RequestParam(value = "page", required = false) Integer page, @RequestParam(value = "size", required = false) Integer size, Model uiModel) {
        if (page != null || size != null) {
            int sizeNo = size == null ? 10 : size.intValue();
            uiModel.addAttribute("customers", Customer.findCustomerEntries(page == null ? 0 : (page.intValue() - 1) * sizeNo, sizeNo));
            float nrOfPages = (float) Customer.countCustomers() / sizeNo;
            uiModel.addAttribute("maxPages", (int) ((nrOfPages > (int) nrOfPages || nrOfPages == 0.0) ? nrOfPages + 1 : nrOfPages));
        } else {
            uiModel.addAttribute("customers", Customer.findAllCustomers());
        }
        return "customers/list";
    }
    
    @RequestMapping(method = RequestMethod.PUT)
    public String CustomerController.update(@Valid Customer customer, BindingResult bindingResult, Model uiModel, HttpServletRequest httpServletRequest) {
        if (bindingResult.hasErrors()) {
            uiModel.addAttribute("customer", customer);
            return "customers/update";
        }
        uiModel.asMap().clear();
        customer.merge();
        return "redirect:/customers/" + encodeUrlPathSegment(customer.getCustomerId().toString(), httpServletRequest);
    }
    
    @RequestMapping(value = "/{customerId}", params = "form", method = RequestMethod.GET)
    public String CustomerController.updateForm(@PathVariable("customerId") Long customerId, Model uiModel) {
        uiModel.addAttribute("customer", Customer.findCustomer(customerId));
        return "customers/update";
    }
    
    @RequestMapping(value = "/{customerId}", method = RequestMethod.DELETE)
    public String CustomerController.delete(@PathVariable("customerId") Long customerId, @RequestParam(value = "page", required = false) Integer page, @RequestParam(value = "size", required = false) Integer size, Model uiModel) {
        Customer.findCustomer(customerId).remove();
        uiModel.asMap().clear();
        uiModel.addAttribute("page", (page == null) ? "1" : page.toString());
        uiModel.addAttribute("size", (size == null) ? "10" : size.toString());
        return "redirect:/customers";
    }
    
    @ModelAttribute("cartorders")
    public Collection<CartOrder> CustomerController.populateCartOrders() {
        return CartOrder.findAllCartOrders();
    }
    
    @ModelAttribute("companys")
    public Collection<Company> CustomerController.populateCompanys() {
        return Company.findAllCompanys();
    }
    
    @ModelAttribute("customers")
    public Collection<Customer> CustomerController.populateCustomers() {
        return Customer.findAllCustomers();
    }
    
    String CustomerController.encodeUrlPathSegment(String pathSegment, HttpServletRequest httpServletRequest) {
        String enc = httpServletRequest.getCharacterEncoding();
        if (enc == null) {
            enc = WebUtils.DEFAULT_CHARACTER_ENCODING;
        }
        try {
            pathSegment = UriUtils.encodePathSegment(pathSegment, enc);
        }
        catch (UnsupportedEncodingException uee) {}
        return pathSegment;
    }
    
}
